# Create a worker relation

POST https://api.letsdeel.com/rest/v2/hris/worker_relations/profile
Content-Type: application/json

Create a hierarchical relation between a worker and its subordinates.
 **Token scopes**: `profile:write`

Reference: https://developer.deel.com/api/reference/endpoints/worker-relations/create-worker-relation

## OpenAPI Specification

```yaml
openapi: 3.1.0
info:
  title: Deel HRIS SCIM API
  version: 1.0.0
paths:
  /hris/worker_relations/profile:
    post:
      operationId: create-worker-relation
      summary: Create a worker relation
      description: |-
        Create a hierarchical relation between a worker and its subordinates.
         **Token scopes**: `profile:write`
      tags:
        - subpackage_workerRelations
      parameters:
        - name: Authorization
          in: header
          description: >
            ## Authentication

            The Deel API uses bearer tokens to authenticate requests. All API
            calls must be made over HTTPS — calls over plain HTTP or without
            authentication will fail.


            ```curl

            curl -X GET 'https://api.letsdeel.com/rest/v2/contracts' \
              -H 'Authorization: Bearer YOUR-TOKEN-HERE'
            ```


            [Learn more about authentication](/api/authentication)
          required: true
          schema:
            type: string
      responses:
        '201':
          description: Successful operation
          content:
            application/json:
              schema:
                $ref: >-
                  #/components/schemas/Worker
                  Relations_createWorkerRelation_Response_201
        '400':
          description: Operation failed.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ApiErrorContainer'
        '401':
          description: Operation failed.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ApiErrorContainer'
        '403':
          description: Operation failed.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ApiErrorContainer'
        '404':
          description: Operation failed.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ApiErrorContainer'
        '500':
          description: Operation failed.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ApiErrorContainer'
      requestBody:
        content:
          application/json:
            schema:
              type: object
              properties:
                data:
                  $ref: >-
                    #/components/schemas/HrisWorkerRelationsProfilePostRequestBodyContentApplicationJsonSchemaData
servers:
  - url: https://api.letsdeel.com/rest/v2
  - url: https://api-staging.letsdeel.com/rest/v2
components:
  schemas:
    HrisWorkerRelationsProfilePostRequestBodyContentApplicationJsonSchemaData:
      type: object
      properties:
        child_hris_profile_ids:
          type: array
          items:
            type: string
            format: uuid
          description: An array containing the secondary HrisProfiles IDs.
        parent_hris_profile_id:
          type: string
          format: uuid
          description: Primary HrisProfile ID
        hris_relationship_type_id:
          type: string
          format: uuid
          description: The ID of the Worker Relation Type.
      required:
        - child_hris_profile_ids
        - parent_hris_profile_id
        - hris_relationship_type_id
      title: >-
        HrisWorkerRelationsProfilePostRequestBodyContentApplicationJsonSchemaData
    Worker Relations_createWorkerRelation_Response_201:
      type: object
      properties: {}
      description: Empty response body
      title: Worker Relations_createWorkerRelation_Response_201
    ApiErrorRequest:
      type: object
      properties:
        method:
          type: string
          description: The HTTP method of the failed request
        url:
          type: string
          description: The relative URL of the failed request
        status:
          type: number
          format: double
          description: The status code of the response
        api_req_id:
          type: string
          description: The request ID of the failed request
        docs:
          type: string
          description: >-
            A link to the official documentation for the requested endpoint
            resource
        source:
          type: string
          description: The source handler which produced the returned error
        code:
          type: number
          format: double
          description: The code of the source handler which produced the returned error
      title: ApiErrorRequest
    ApiError:
      type: object
      properties:
        message:
          type: string
          description: A description of the returned error
        path:
          type: string
          description: The JSON path where input validation failed
      title: ApiError
    ApiErrorContainer:
      type: object
      properties:
        request:
          $ref: '#/components/schemas/ApiErrorRequest'
        errors:
          type: array
          items:
            $ref: '#/components/schemas/ApiError'
      title: ApiErrorContainer
  securitySchemes:
    deelToken:
      type: http
      scheme: bearer
      description: >
        ## Authentication

        The Deel API uses bearer tokens to authenticate requests. All API calls
        must be made over HTTPS — calls over plain HTTP or without
        authentication will fail.


        ```curl

        curl -X GET 'https://api.letsdeel.com/rest/v2/contracts' \
          -H 'Authorization: Bearer YOUR-TOKEN-HERE'
        ```


        [Learn more about authentication](/api/authentication)
    oauth2:
      type: http
      scheme: bearer
      description: >-
        Standard OAuth2 security scheme based on
        https://swagger.io/docs/specification/authentication/

```

## SDK Code Examples

```python
import requests

url = "https://api.letsdeel.com/rest/v2/hris/worker_relations/profile"

payload = { "body": { "data": {
            "parent_hris_profile_id": "a3f1c9d2-4b7e-4f9a-8c3d-2e5f7b9a1c23",
            "child_hris_profile_ids": ["b4d2e1f3-5c6a-4d7b-9e8f-3a2b1c4d5e6f", "c5e3f2a4-6d7b-5e8c-0f9a-4b3c2d5e6f7a"],
            "hris_relationship_type_id": "d6f4a3b5-7e8c-0f9a-1b2c-3d4e5f6a7b8c"
        } } }
headers = {
    "Authorization": "Bearer <token>",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.json())
```

```javascript
const url = 'https://api.letsdeel.com/rest/v2/hris/worker_relations/profile';
const options = {
  method: 'POST',
  headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
  body: '{"body":{"data":{"parent_hris_profile_id":"a3f1c9d2-4b7e-4f9a-8c3d-2e5f7b9a1c23","child_hris_profile_ids":["b4d2e1f3-5c6a-4d7b-9e8f-3a2b1c4d5e6f","c5e3f2a4-6d7b-5e8c-0f9a-4b3c2d5e6f7a"],"hris_relationship_type_id":"d6f4a3b5-7e8c-0f9a-1b2c-3d4e5f6a7b8c"}}}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://api.letsdeel.com/rest/v2/hris/worker_relations/profile"

	payload := strings.NewReader("{\n  \"body\": {\n    \"data\": {\n      \"parent_hris_profile_id\": \"a3f1c9d2-4b7e-4f9a-8c3d-2e5f7b9a1c23\",\n      \"child_hris_profile_ids\": [\n        \"b4d2e1f3-5c6a-4d7b-9e8f-3a2b1c4d5e6f\",\n        \"c5e3f2a4-6d7b-5e8c-0f9a-4b3c2d5e6f7a\"\n      ],\n      \"hris_relationship_type_id\": \"d6f4a3b5-7e8c-0f9a-1b2c-3d4e5f6a7b8c\"\n    }\n  }\n}")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("Authorization", "Bearer <token>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://api.letsdeel.com/rest/v2/hris/worker_relations/profile")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n  \"body\": {\n    \"data\": {\n      \"parent_hris_profile_id\": \"a3f1c9d2-4b7e-4f9a-8c3d-2e5f7b9a1c23\",\n      \"child_hris_profile_ids\": [\n        \"b4d2e1f3-5c6a-4d7b-9e8f-3a2b1c4d5e6f\",\n        \"c5e3f2a4-6d7b-5e8c-0f9a-4b3c2d5e6f7a\"\n      ],\n      \"hris_relationship_type_id\": \"d6f4a3b5-7e8c-0f9a-1b2c-3d4e5f6a7b8c\"\n    }\n  }\n}"

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://api.letsdeel.com/rest/v2/hris/worker_relations/profile")
  .header("Authorization", "Bearer <token>")
  .header("Content-Type", "application/json")
  .body("{\n  \"body\": {\n    \"data\": {\n      \"parent_hris_profile_id\": \"a3f1c9d2-4b7e-4f9a-8c3d-2e5f7b9a1c23\",\n      \"child_hris_profile_ids\": [\n        \"b4d2e1f3-5c6a-4d7b-9e8f-3a2b1c4d5e6f\",\n        \"c5e3f2a4-6d7b-5e8c-0f9a-4b3c2d5e6f7a\"\n      ],\n      \"hris_relationship_type_id\": \"d6f4a3b5-7e8c-0f9a-1b2c-3d4e5f6a7b8c\"\n    }\n  }\n}")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://api.letsdeel.com/rest/v2/hris/worker_relations/profile', [
  'body' => '{
  "body": {
    "data": {
      "parent_hris_profile_id": "a3f1c9d2-4b7e-4f9a-8c3d-2e5f7b9a1c23",
      "child_hris_profile_ids": [
        "b4d2e1f3-5c6a-4d7b-9e8f-3a2b1c4d5e6f",
        "c5e3f2a4-6d7b-5e8c-0f9a-4b3c2d5e6f7a"
      ],
      "hris_relationship_type_id": "d6f4a3b5-7e8c-0f9a-1b2c-3d4e5f6a7b8c"
    }
  }
}',
  'headers' => [
    'Authorization' => 'Bearer <token>',
    'Content-Type' => 'application/json',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://api.letsdeel.com/rest/v2/hris/worker_relations/profile");
var request = new RestRequest(Method.POST);
request.AddHeader("Authorization", "Bearer <token>");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{\n  \"body\": {\n    \"data\": {\n      \"parent_hris_profile_id\": \"a3f1c9d2-4b7e-4f9a-8c3d-2e5f7b9a1c23\",\n      \"child_hris_profile_ids\": [\n        \"b4d2e1f3-5c6a-4d7b-9e8f-3a2b1c4d5e6f\",\n        \"c5e3f2a4-6d7b-5e8c-0f9a-4b3c2d5e6f7a\"\n      ],\n      \"hris_relationship_type_id\": \"d6f4a3b5-7e8c-0f9a-1b2c-3d4e5f6a7b8c\"\n    }\n  }\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = [
  "Authorization": "Bearer <token>",
  "Content-Type": "application/json"
]
let parameters = ["body": ["data": [
      "parent_hris_profile_id": "a3f1c9d2-4b7e-4f9a-8c3d-2e5f7b9a1c23",
      "child_hris_profile_ids": ["b4d2e1f3-5c6a-4d7b-9e8f-3a2b1c4d5e6f", "c5e3f2a4-6d7b-5e8c-0f9a-4b3c2d5e6f7a"],
      "hris_relationship_type_id": "d6f4a3b5-7e8c-0f9a-1b2c-3d4e5f6a7b8c"
    ]]] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://api.letsdeel.com/rest/v2/hris/worker_relations/profile")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```